using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySQLMobileNET;

namespace TestAppCSharp
{
	public partial class Form1 : Form
	{
		private MySQLMobile mysqlMobile = null;


		public Form1()
		{
			InitializeComponent();
			this.mysqlMobile = new MySQLMobile();
		}

		private void runButton_Click(object sender, EventArgs e)
		{
			try
			{
				AddMessage("* setting properties...");
				mysqlMobile.SetEncoding(437); // 437 = Extended ASCII set: OEM United States
				mysqlMobile.SetBufferSize(16 * 1024); // Set buffer size to 16K in stead of default size(8K)
				AddMessage("* connecting...");
				mysqlMobile.Connect("10.0.0.100", 3306, "root", "root");
				AddMessage("* connected, selecting db...");
				mysqlMobile.SelectDB("mysql");
				AddMessage("* db selected, executing query...");
				mysqlMobile.ExecuteQuery("SELECT * FROM user");
				AddMessage("* query executed, displaying results...");
				DisplayRecords(mysqlMobile);

			}
			catch (MySQLMobileException mysqlMobileException)
			{
				AddMessage("Exception from mysqlMobile: " + mysqlMobileException.Message);
			}
			catch (Exception ex)
			{
				AddMessage("Unhandled exception: " + ex.Message);
			}
			finally
			{
				try
				{
					AddMessage("* disconnecting...");
					mysqlMobile.Disconnect();
				}
				catch (MySQLMobileException mysqlMobileException)
				{
					AddMessage("Exception from mysqlMobile: " + mysqlMobileException.Message);
				}
				catch (Exception ex)
				{
					AddMessage("Unhandled exception: " + ex.Message);
				}
			}

			AddMessage("* done");
		}	

		private void DisplayRecords(MySQLMobile mysqlMobile)
		{
			AddMessage("--------------------------------------------------");
			List<string> fields = mysqlMobile.GetFields();
			string temp = "";
			foreach (string field in fields)
			{
				temp += field + "\t\t";
			}
			AddMessage("fields: " + temp);

			for (int i = 0; i < mysqlMobile.GetRowCount(); i++)
			{
				List<string> rowData = mysqlMobile.GetRowData(i);
				temp = "";
				foreach (string record in rowData)
				{
					temp += record + "\t\t";
				}
				AddMessage("record: " + temp);
			}
			AddMessage("--------------------------------------------------");
		}

		private void AddMessage(string message)
		{
			textBox.Text += message + "\r\n";
		}

		private void menuItem2_Click(object sender, EventArgs e)
		{
			Application.Exit();
		}

	}
}