Imports System.Text
Imports MySQLMobileNET

Public Class Form1

    Private mysqlMobile As MySQLMobile = Nothing

    Public Sub New()
        InitializeComponent()
        mysqlMobile = New MySQLMobile()
    End Sub

    Private Sub fnAddMessage(ByVal str As String)
        Dim MyCrLF As String = ChrW(13) + ChrW(10)
        TextBox1.Text = TextBox1.Text + str + MyCrLF
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectBtn.Click
        Try
            ' Set encoding
            mysqlMobile.SetEncoding(437) '437 = Extended ASCII set: OEM United States

            ' Set buffer size to 16K in stead of default size(8K)
            mysqlMobile.SetBufferSize(16 * 1024)

            ' Uncomment the line below if you want to force compressionless communication with the MySQL server.
            'mysqlMobile.EnableCompression(False)

            ' Connect to mySQL
            Dim connForm As ConnectForm = New ConnectForm
            If (connForm.ShowDialog = Windows.Forms.DialogResult.OK) Then
                If (connForm.m_Host = "") Then Return

                mysqlMobile.Connect(connForm.m_Host, connForm.m_Port, connForm.m_Username, connForm.m_Password)
                fnAddMessage("Connect() successful")
            End If
        Catch mySQLMobileException As MySQLMobileException
            fnAddMessage("MySQLMobile exception: " + mySQLMobileException.Message)
        Catch exception As Exception
            fnAddMessage("Unhandled exception: " + exception.Message)
        End Try
    End Sub

    Private Sub DisconnectBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisconnectBtn.Click
        ' Disconnect from mySQL
        Try
            mysqlMobile.Disconnect()
            fnAddMessage("Disconnect() successful")
        Catch ex As MySQLMobileException
            fnAddMessage(ex.Message)
        End Try
    End Sub

    Private Sub SelectDBBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectDBBtn.Click
        Dim stringForm As StringForm = New StringForm
        stringForm.SetTitle("Enter database name:")
        If (stringForm.ShowDialog = Windows.Forms.DialogResult.OK) Then
            Try
                mysqlMobile.SelectDB(stringForm.m_String)
                fnAddMessage("SelectDB() successful")
            Catch ex As MySQLMobileException
                fnAddMessage(ex.Message)
            End Try
        End If
    End Sub

    Private Sub ExecBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExecBtn.Click
        StringForm.SetTitle("Enter query (we recommend that you use the LIMIT keyword in SELECT queries)")
        If (StringForm.ShowDialog = Windows.Forms.DialogResult.OK) Then
            Try
                mysqlMobile.ExecuteQuery(StringForm.m_String)
                fnAddMessage("ExecuteQuery() successful")
            Catch ex As MySQLMobileException
                fnAddMessage(ex.Message)
            End Try
        End If
    End Sub

    Private Sub ShowBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowBtn.Click
        fnAddMessage("--------------------------------------------------")
        Try
            Dim fields As List(Of String) = mysqlMobile.GetFields()
            Dim temp As String = ""
            For Each field As String In fields
                temp += field + Chr(9) + Chr(9)
            Next
            fnAddMessage("fields: " + temp)
            For i As Integer = 0 To mysqlMobile.GetRowCount() - 1

                Dim rowData As List(Of String) = mysqlMobile.GetRowData(i)
                temp = ""
                For Each record As String In rowData
                    temp += record + Chr(9) + Chr(9)
                Next
                fnAddMessage("record: " + temp)
            Next

        Catch ex As MySQLMobileException
            fnAddMessage(ex.Message)
        End Try
        fnAddMessage("--------------------------------------------------")
    End Sub

    Private Sub ExitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
        Application.Exit()
    End Sub
End Class
